bots={}
for i=1,32 do
	bots[i]={}
end

function newBot()
	local self={}
	return {
		joinGame=function()
			if self.id==nil then
				if #player(0,"table")<tonumber(game("sv_maxplayers")) then 
					for tmp=1,32 do
						if player(tmp,"exists")==false then
							self.id=tmp
							bots[self.id]["autoTeam"]=true
							parse("bot_add")
							return
						end
					end
				else
					return false,"Server is full."
				end
			else
				return false,"This bot has already joined the game."
			end
		end,
		joinTeam=function(team)
			if hasJoined(self.id) then
				team=team+1
				if team==4 then
					if #player(0,"team1")>#player(0,"team2") then
						team=3
					else
						team=2
					end
				end
				local args={"spec","t","ct"}
				local names={"","terrorist","counter-terrorist"}
				if game("mp_autoteambalance")=="1" then
					if team==2 and #player(0,"team1")>#player(0,"team2") or team==3 and #player(0,"team2")>#player(0,"team1") then
						return false,"Too many players on "..names[team].."."
					end
				end
				parse("make"..args[team].." "..self.id)
			end
			return hasJoined(self.id)
		end,
		leaveGame=function()
			if hasJoined(self.id) then
				parse("kick "..self.id)
				self.id=nil
			else
				return hasJoined(self.id)
			end
		end,
		hasJoined=function()
			return hasJoined(self.id)
		end,
		onDeadFrame=function(func)
			if hasJoined(self.id) then
				bots[self.id]["onDeadFrame"]=func
			end
			return hasJoined(self.id)
		end,
		onLiveFrame=function(func)
			if hasJoined(self.id) then
				bots[self.id]["onLiveFrame"]=func
			end
			return hasJoined(self.id)
		end,		
		onSpawn=function(func)
			if hasJoined(self.id) then
				bots[self.id]["onSpawn"]=func
			end
			return hasJoined(self.id)
		end,	
		onRadio=function(func)
			if hasJoined(self.id) then
				bots[self.id]["onRadio"]=func
			end
			return hasJoined(self.id)
		end,
		onChat=function(func)
			if hasJoined(self.id) then
				bots[self.id]["onChat"]=func
			end
			return hasJoined(self.id)
		end,
		spawn=function()
			if hasJoined(self.id) then
				if game("sv_gamemode")~="0" then
					ai_respawn(self.id)
				else
					return false,"Bots cannot respawn while gamemode is standard."
				end
			end
			return hasJoined(self.id)
		end,
		say=function(message)
			if hasJoined(self.id) then
				ai_say(self.id,message)
			end
			return hasJoined(self.id)
		end,
		sayTeam=function(message)
			if hasJoined(self.id) then
				ai_sayteam(self.id,message)
			end
			return hasJoined(self.id)
		end,
		radio=function(radioID)
			if isAlive(self.id) then
				ai_radio(self.id,radioID)
			end
			return isAlive(self.id)
		end,
		moveTowards=function(x,y,walk)
			if isAlive(self.id) then
				ai_goto(self.id,x,y,walk)
			end
			return isAlive(self.id)
		end,
		getID=function(message)
			if hasJoined(self.id) then
				return self.id
			end
			return hasJoined(self.id)
		end,
		aimCursor=function(x,y)
			if isAlive(self.id) then
				ai_aim(self.id,x,y)
			end
			return isAlive(self.id)
		end,
		setRotation=function(angle)
			if isAlive(self.id) then
				ai_rotate(self.id,angle)
			end
			return isAlive(self.id)
		end,
		dropWeapon=function(weapon)
			if isAlive(self.id) then
				ai_drop(self.id)
			end
			return isAlive(self.id)
		end,
		spray=function()
			if isAlive(self.id) then
				ai_spray()
			end
			return isAlive(self.id)
		end,
		reload=function()
			if isAlive(self.id) then
				ai_reload()
			end
			return isAlive(self.id)
		end,
		build=function(building,x,y)
			if isAlive(self.id) then
				if hasWeapon(self.id,74) then
					ai_build(self.id,building,x,y)
				end
				return hasWeapon(self.id,74)
			end
			return isAlive(self.id)
		end,
		getTarget=function()
			if isAlive(self.id) then
				return ai_findtarget(self.id)
			end
			return isAlive(self.id)
		end,
		isFreeLine=function(x,y)
			if isAlive(self.id) then
				return ai_freeline(self.id,x,y)
			end
			return isAlive(self.id)
		end,
		smartAttack=function()
			if isAlive(self.id) then
				ai_iattack(self.id)
			end
			return isAlive(self.id)
		end,
		attack=function()
			if isAlive(self.id) then
				ai_attack(id)
			end
			return isAlive(self.id)
		end,
		attack2=function()
			if isAlive(self.id) then
				ai_attack(id,1)
			end
			return isAlive(self.id)
		end,
		buy=function(item)
			if isAlive(self.id) then
				ai_buy(self.id,item)
			end
			return isAlive(self.id)
		end,
		use=function()
			if isAlive(self.id) then
				ai_use(self.id)
			end
			return isAlive(self.id)
		end,
		setWeapon=function(item)
			if isAlive(self.id) then
				if hasWeapon(item) then
					ai_selectweapon(self.id,item)
				end
				return hasWeapon(item)
			end
			return isAlive(self.id)
		end,
		debugText=function(text)
			ai_debug(self.id,text)
		end
	}
end

function showErrors(bool,message)
	if bool==false then
		print(string.char(169).."255000000BOT ERROR: "..message)
	end
end

addhook("team","__team")
function __team(id)
	if bots[id]["autoTeam"] then
		bots[id]["autoTeam"]=false
		return 1
	end
end

addhook("leave","__leave")

function __leave(id)
	if player(id,"bot") then
		bots[id]=nil
	end
end

function ai_update_dead(id)
	if bots[id]["onDeadFrame"]~=nil then
		bots[id]["onDeadFrame"]()
	end
end

function ai_update_living(id)
	if bots[id]["onLiveFrame"]~=nil then
		bots[id]["onLiveFrame"]()
	end
end

function ai_onspawn(id)
	if bots[id]["onSpawn"]~=nil then
		bots[id]["onSpawn"]()
	end
end

function ai_hear_radio(source,radio)
	for i=1,32 do
		if bots[i]~=nil and bots[i]["onRadio"]~=nil then
			bots[i]["onRadio"](source,radio)
		end
	end
end

function ai_hear_chat(source,message,teamonly)
	for i=1,32 do
		if bots[i]["onChat"]~=nil then
			bots[i]["onChat"](source,message,teamonly)
		end
	end
end

function hasWeapon(id,weapon)
	for _,wep in ipairs(playerweapons(id)) do
		if wep==weapon then
			return true
		end
	end
	return false,"ID: "..id.." does not have weapon: "..weapon.."."
end

function hasJoined(id)
	return player(id,"exists"),"ID: "..id.." does not exist."
end

function isAlive(id)
	if hasJoined(id) then
		return player(id,"health")>0,"ID: "..id.." is dead."
	end
	return hasJoined(id)
end